﻿//*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
//  Part of this code was taken from:
//  https://docs.microsoft.com/en-us/dotnet/api/system.security.cryptography.md5
//  https://support.microsoft.com/en-za/help/307020/how-to-compute-and-compare-hash-values-by-using-visual-c
//*****************************************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace TDP.BaseServices.Infrastructure.Security
{
    public class Hash
    {
        private Hash()
        {
        }

        public static byte[] ComputeHash(byte[] data)
        {
            using (MD5 MD5Hash = MD5.Create())
            {
                return MD5Hash.ComputeHash(data);
            }
        }

        public static bool CompareHash(byte[] hash1, byte[] hash2)
        {
            bool IsEqual = false;
            if (hash1.Length == hash2.Length)
            {
                int i = 0;
                while ((i < hash1.Length) && (hash1[i] == hash2[i]))
                {
                    i += 1;
                }
                
                if (i == hash1.Length)
                {
                    IsEqual = true;
                }
            }

            return IsEqual;
        }

        public static bool VerifyHash(byte[] data, byte[] hash)
        {
            byte[] NewHash = ComputeHash(data);

            return CompareHash(hash, NewHash);
        }

        public static string HashToHexString(byte[] hash)
        {
            StringBuilder StrBuilder = new StringBuilder();

            for (int i = 0; i < hash.Length; i++)
            {
                StrBuilder.Append(hash[i].ToString("x2"));
            }

            return StrBuilder.ToString();
        }
    }
}
