﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;
using TDP.BaseServices.Infrastructure.Configuration;
using TDP.BaseServices.Infrastructure.Net;
using TDP.BaseServices.Infrastructure.Security;

namespace TestApp
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Test SocketHelper");

            Task T1 = new Task(() => {
                Console.WriteLine("Initializing task T1...");

                Socket SocketServer = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                IPAddress MyIPAddress = IPAddress.Parse("127.0.0.1");
                IPEndPoint MyEndPoint = new IPEndPoint(MyIPAddress, 10000);
                SocketServer.Bind(MyEndPoint);
                SocketServer.Listen(0);
                
                Console.WriteLine("Task T1 waiting for connections...");
                Socket SocketClient = SocketServer.Accept();

                string Message = SocketHelper.ReceiveObject<string>(SocketClient);
                Console.WriteLine("Received message: "  + Message);

                NetworkStream NS = new NetworkStream(SocketClient);
                Message = SocketHelper.ReceiveObject<string>(NS);
                Console.WriteLine("Received message: " + Message);
            });
            T1.Start();

            System.Threading.Thread.Sleep(2000);

            Task T2 = new Task(() => {
                Console.WriteLine("Initializing task T2...");

                Socket SocketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                IPAddress MyIPAddress = IPAddress.Parse("127.0.0.1");
                IPEndPoint MyEndPoint = new IPEndPoint(MyIPAddress, 10000);
                SocketClient.Connect(MyEndPoint);

                Console.WriteLine("Sending message: Hello with socket!!");
                SocketHelper.SendObject(SocketClient, "Hello with socket!!");
                System.Threading.Thread.Sleep(2000);

                Console.WriteLine("Sending message: Hello with stream!!");
                NetworkStream NS = new NetworkStream(SocketClient);
                SocketHelper.SendObject(NS, "Hello with stream!!");
            });
            T2.Start();

            Console.ReadLine();


            }
    }
}
